/*
 * Refuel.java
 *
 * Created on 15  2006 ., 17:58
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

        
package CarCalc;

import java.util.*;
import java.io.*;
import javax.microedition.rms.*;
import javax.microedition.io.*;

        
/**
 *
 * @author Ivan
 */
public class Refuel extends Object {
    
    public int      iOdometer;
    public long     lDate;
    public float    fLiters;
    public float    fPrice;
    public String   strRemark;
    public int      iReserved1;
    public int      iReserved2;
    private boolean bMustBeSaved;
    /**
     * Creates a new instance of Refuel 
     */
    public Refuel() 
    {
        iOdometer = 0;
        fLiters = 0;
        lDate = 0;
        fPrice = 0;
        strRemark = "";        
        iReserved1 = 95;
        iReserved2 = 0;
        bMustBeSaved = true;
    }
    public Refuel(int AOdometer, long ADate, float ALiters, float APrice, String ARemark) 
    {
        iOdometer = AOdometer;
        fLiters = ALiters;
        if(0==ADate)
        {
            Date dt=new Date(0);
            ADate = dt.getTime();
        }
        lDate = ADate;
        fPrice = APrice;
        strRemark = ARemark;
        bMustBeSaved = true;
    }
    public boolean SaveToRecordStore(int RecordId, RecordStore rs)
    {
        if(!bMustBeSaved) return true;
        
        boolean bResult = true;
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(baos);
        try
        {
            dos.writeInt(iOdometer);
            dos.writeLong(lDate);
            dos.writeFloat(fLiters);
            dos.writeFloat(fPrice);
            dos.writeUTF(strRemark);
            dos.writeInt(iReserved1);
            dos.writeInt(iReserved2);       
        }
        catch(IOException ioe)
        {
            dos  = null;
            baos = null;         
            return false;
        }
        try
        {
            rs.setRecord(RecordId, baos.toByteArray(),0, baos.toByteArray().length);
        }
        catch (InvalidRecordIDException ridex) 
        {
            try 
            {
                rs.addRecord(baos.toByteArray(), 0, baos.toByteArray().length);            
            }              
            catch (RecordStoreException ex) 
            {
                return false;
            }
        } 
        catch (RecordStoreException ex) 
        {
        }
        bMustBeSaved = false;
        return bResult;
    }
    
    public boolean LoadFromRecordStore(int RecordId, RecordStore rs)
    {
        boolean bResult = true;
        byte[] arrData;
        try
        {
            arrData = rs.getRecord(RecordId);            
        }
        catch (RecordStoreException ex) 
        {
            return false;            
        }        
        ByteArrayInputStream bais = new ByteArrayInputStream(arrData);
        DataInputStream dis = new DataInputStream(bais);
        try
        {   
            iOdometer = dis.readInt();
            lDate     = dis.readLong();
            fLiters   = dis.readFloat();
            fPrice    = dis.readFloat();
            strRemark = dis.readUTF();
//            iReserved1= dis.readInt();
//            iReserved2= dis.readInt();
        }
        catch(IOException ioe)
        {
            dis  = null;
            bais = null;         
            return false;
        }
        dis  = null;
        bais = null;
        if(lDate==0)
        {
            return false;
        }
        bMustBeSaved = false;
        return bResult;
    }
    
}
